﻿//【登録場所】 "V2C\script\system\getdat.js"
//【内容】 スレッドのログが取得出来ない場合、指定するURLから過去ログを取得する。
//【スクリプト】
function createDatUrls(url)
{
    var pattern = "htt"+"p:/+([^/]+)/.*read[^/]+/([^/]+)/(\\d+).*$";
        return [
                { name: "mimizun", url: url.replaceAll(pattern, "htt"+"p://mimizun.com/log/2ch/$2/$3.dat") },
                { name: "unkar", url: url.replaceAll(pattern, "htt"+"p://unkar.org/convert.php/$2/$3") },
		{ name: "ヴァルダ", url: url.replaceAll("htt"+"p:/+([^/]+)/.*read[^/]+/([^/]+)/(((\\d{4})\\d)\\d{5}).*$", "htt"+"p://varda2.com/log/2ch/$2/$1/$2/kako/$5/$4/$3.dat") }
        ];
}
 
function getDat(thread)
{
        if(!thread.bbs.is2ch)
                return null;
 
        var services = createDatUrls(thread.url.toString());
 
        var retrievedResCount = thread.localResCount;
        var dat = null;
        for(var i = 0; retrievedResCount < 1001 && i < services.length; i++)
        {
                v2c.setStatus("過去ログを取得中........( ´∀｀)つ旦 " + services[i].name);
 
                var content = getThreadLog(services[i].url);
                if(!content)
                        continue;
 
                var resCount = content.split("\n").length;
 
                printlnLog("{0} ({1}): {2}", services[i].name, resCount, services[i].url);
 
                if(retrievedResCount < resCount)
                {
                        dat = { service: services[i], content: content };
                        retrievedResCount = resCount;
                }
        }
 
        var found = dat ? "retrieved from " + dat.service.name : "not found";
        printlnLog("{0}: {1} (+{2})", found, thread.title, retrievedResCount - thread.localResCount);
 
        return dat ? dat.content : null;
}
 
function getThreadLog(url)
{
        var req = v2c.createHttpRequest(url);
 
        var content = req.getContentsAsString();
        if(!content || req.responseCode != 200)
                return null;
        
        return content;
}
 
function printlnLog(format /*, ...*/)
{
    var args = arguments;
    var message = format.replace(/\{(\d)\}/g, function(m, c) { return args[parseInt(c) + 1] });
 
    v2c.println("[getdat.js] " + message);
}